=== debian/changelog ===
eliom (4.0.0-2) unstable; urgency=medium

  * debian/patches:
    + Fix build on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Thu, 10 Jul 2014 09:39:42 +0200

eliom (4.0.0-1) unstable; urgency=medium

  * New upstream release
  * debian/patches:
    + Install .o files with .cmx files
  * Bump debhelper compat level to 9
  * Bump Standards-Version to 3.9.5
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sun, 29 Jun 2014 13:57:29 +0200

eliom (3.0.3-5) unstable; urgency=medium

  * Team upload.
  * Fix ocamldoc invocation for doc/{server,client} (Closes: #746094).
    - Add 0001-Fix-ocamldoc-invocation-in-src-server-client.patch
  * Bump build-dependency on ocaml-find to 1.4.1, as a consequence of the patch
    introduced to fix the FTBFS issue.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 10 May 2014 17:12:48 +0200
