=== debian/watch ===
version=3
http://ocsigen.org/eliom/install .*/archive/(.*)\.tar\.gz
